﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Data.SqlClient;
using System.DirectoryServices;
using System.Net;

// RESULTADO DE TRABAJO ACADÉMICO POLITÉCNICO GRANCOLOMBIANO

public class CPOserv
{
    SqlConnection co;
    public String uadm;
    public String padm;
    public String pnre;

	public CPOserv()
    {
        System.Configuration.Configuration rootWebConfig =
            System.Web.Configuration.WebConfigurationManager.OpenWebConfiguration("/AQUISITIO");
        System.Configuration.ConnectionStringSettings connString = rootWebConfig.ConnectionStrings.ConnectionStrings["VA"];
        co = new SqlConnection(connString.ConnectionString);
        String[] ad = rootWebConfig.AppSettings.Settings["AD"].Value.Split('|');
        uadm = ad[0];
        padm = "+" + ad[1] + "+";
        pnre = rootWebConfig.AppSettings.Settings["NR"].Value;
	}
    public Requ_t loadRequ(String guid)
    {
        Requ_t requ = null;
        co.Open();
        SqlCommand cm = new SqlCommand("select docu,usrn,guid from t_pass_rst where guid='" + guid + "' and fech>dateadd(minute,-15,getdate()) and camb is null", co);
        SqlDataReader dr = cm.ExecuteReader();
        if (dr.Read())
        {
            requ = new Requ_t();
            requ.docu = dr.GetValue(0).ToString();
            requ.usrn = dr.GetValue(1).ToString();
            requ.guid = dr.GetValue(2).ToString();
        }
        dr.Close();
        co.Close();
        return requ;
    }
    public void changeDB(Requ_t requ, String addr)
    {
        co.Open();
        SqlCommand cm = new SqlCommand("update t_pass_rst set camb=getdate(),ip=@ip where guid='" + requ.guid + "'", co);
        cm.Parameters.AddWithValue("@ip", addr);
        cm.ExecuteNonQuery();
        co.Close();
    }
    public void cambADSuper(String usrn, String clav)
    {
        String strpath = "LDAP://AQUILDAP";
        DirectoryEntry deRoot = new DirectoryEntry(strpath, uadm, padm);
        DirectorySearcher search = new DirectorySearcher(deRoot);
        search.Filter = "(SAMAccountName=" + usrn + ")";
        SearchResult r = search.FindOne();
        if (r == null) throw new Exception("No existe!");
//        if (!r.Path.Contains("OU=ESTUDIANTES")) throw new Exception("No es estudiante");
        DirectoryEntry de = r.GetDirectoryEntry();
        de.Invoke("SetPassword", clav);
        de.CommitChanges();
        deRoot.Close();
    }
    public void valiAD(String usrn, String clav)
    {
        String strpath = "LDAP://AQUILDAP";
        DirectoryEntry deRoot = new DirectoryEntry(strpath, usrn, clav);
        DirectorySearcher search = new DirectorySearcher(deRoot);
        search.Filter = "(SAMAccountName=" + usrn + ")";
        SearchResult r = search.FindOne();
        if (r == null) throw new Exception("No existe!");
//        if (!r.Path.Contains("OU=ESTUDIANTES")) throw new Exception("No es estudiante");
        deRoot.Close();
    }
    public void addlog(String usua, String even, String esta, String addr)
    {
        co.Open();
        SqlCommand cm = new SqlCommand("insert into t_pass(usua,even,esta,fech,ip)values(@usua,@even,@esta,getdate(),@ip)", co);
        cm.Parameters.AddWithValue("@usua", usua);
        cm.Parameters.AddWithValue("@even", even);
        cm.Parameters.AddWithValue("@esta", esta);
        cm.Parameters.AddWithValue("@ip", addr);
        cm.ExecuteNonQuery();
        co.Close();
    }
    public void sendMail(String dst, String subj, String body)
    {
        try
        {
            String fromUser = "AQUICORREO";
            String fromPass = pnre;
            System.Net.Mail.MailMessage message = new System.Net.Mail.MailMessage();
            message.To.Add(dst);
            message.Subject = subj;
            message.From = new System.Net.Mail.MailAddress(fromUser);
            message.IsBodyHtml = true;
            message.Body = body;
            System.Net.Mail.SmtpClient smtp = new System.Net.Mail.SmtpClient("AQUIRELAY");
            smtp.EnableSsl = true;
            smtp.Port = AQUIPUERTO;
            smtp.Credentials = new NetworkCredential(fromUser, fromPass);
            smtp.Send(message);
        }
        catch (Exception ex)
        {
            throw new Exception("Error al enviar el correo! "+ex.Message);
        }
    }
    public Requ_t bldRequ(String docu)
    {
        Requ_t requ = new Requ_t();
        co.Open();
        {
            SqlCommand cm = new SqlCommand("AQUISIA", co);
            cm.Parameters.AddWithValue("@docu", docu);
            SqlDataReader dr = cm.ExecuteReader();
            if (dr.Read())
            {
                requ.docu = dr.GetValue(0).ToString();
                requ.usrn = dr.GetValue(1).ToString();
                requ.emai = dr.GetValue(2).ToString();
                requ.guid = Guid.NewGuid().ToString();
            }
            dr.Close();
        }
        {
            SqlCommand cm = new SqlCommand("insert into t_pass_rst(guid,docu,usrn,fech,emai)values(@guid,@docu,@usrn,getdate(),@emai)", co);
            cm.Parameters.AddWithValue("@guid", requ.guid);
            cm.Parameters.AddWithValue("@docu", requ.docu);
            cm.Parameters.AddWithValue("@usrn", requ.usrn);
            cm.Parameters.AddWithValue("@emai", requ.emai);
            cm.ExecuteNonQuery();
        }
        co.Close();
        return requ;
    }
}

public class Requ_t
{
    public String docu;
    public String usrn;
    public String guid;
    public String nomb;
    public String emai;
}